;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;script .GET Beta
;version 0.01.011 Beta
;release date: 2003-12-02
;Project manager: Urgo
;Coders: Urgo, grimace, knight
;email spam@dotGET.org
;url http://dotGET.org
;dotGET-queue.mrc: Queue file requests
;dotGET-queue.mrc: and view remote queues
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

alias dotGETCheck.bw {
  if ($dotGETResize2($dotGETSend) > $readini(dotGET\dotGET.data,main,maxbw)) { return above }
  else { return below } 
}

alias dotGETqueue.send {
  :queue
  if $lines(dotGET\dotGET.queue) > 0 {
    if ($readini dotGET\dotGET.data main sendsmax > $send(0)) {
      window -h @.GET3 10 10 10000 100
      clear @.GET3
      loadbuf @.GET3 dotGET\dotGET.queue
      var %dotGET.queue.currentline = 1
      :loop
      if $line(@.GET3,1) == $null { goto end }
      var %dotGET.queue.line = $line(@.GET3,%dotGET.queue.currentline)
      var %dotGET.queue.nick = $tcar(%dotGET.queue.line)
      if ($send(%dotGET.queue.nick,0) >= $readini dotGET\dotGET.data main sendseach) { filter -xwwc @.GET3 @.GET3 %dotGET.queue.nick $+ * | goto loop }
      else {
        write -dl1 dotGET\dotGET.queue
        if (%dotGET.queue.nick ison %dotGET.datachan) { 
          if ($readini(dotGET\dotGET.data,stats,sent) == $null) { writeini dotGET\dotGET.data stats sent 1 } 
          else { writeini dotGET\dotGET.data stats sent $calc($readini(dotGET\dotGET.data,stats,sent) + 1) }
          .dcc send -l0 %dotGET.queue.line | dotGETd 4,1Sending %dotGET.queue.line 
        }
        goto queue        
      }
    }
    :end
  }
  window -c @.GET3
}

alias dotGETqueue.add {
  if $lines(dotGET\dotGET.queue) == $null { write -c dotGET\dotGET.queue }
  if $lines(dotGET\dotGET.queue) > $readini dotGET\dotGET.data main queuesmax { .notice $1 My queues are full ( $+ $readini(dotGET\dotGET.data,main,queuesmax) $+ ) . Try again later. Filename: $2- [.GET] | goto end }
  filter -cff dotGET\dotGET.queue dotGET.temp $1 $+ *
  if $lines(dotGET.temp) == $null || $lines(dotGET.temp) < $readini(dotGET\dotGET.data,main,queueseach) {
    filter -cff dotGET.temp dotGET.temp * $+ $2- $+ *
    if $lines(dotGET.temp) == 0 { 
      if ($send(0) == 0) { 
        if ($readini(dotGET\dotGET.data,stats,sent) == $null) { writeini dotGET\dotGET.data stats sent 1 } | else writeini dotGET\dotGET.data stats sent $calc($readini(dotGET\dotGET.data,stats,sent) + 1)
      .dcc send -l0 $1 $2- | dotGETd 7,1Sending file from queue to $1 Filename: $2- }
      else {
        write -a dotGET\dotGET.queue $1 $2- 
        .notice $1 You have been added to queue position $lines(dotGET\dotGET.queue) $+ . Filename: $2- [.GET]
        dotGETd 13,1 $nick added $2- to queue position $lines(dotGET\dotGET.queue)
      }
      else { .notice $1 You already have that file queued. Filename: $2- [.GET] }
    }
  }
  else { .notice $1 You already have the max number of things queued: $readini dotGET\dotGET.data main queueseach things queued.  Try again later. Filename: $2- [.GET] }
  :end
  if $lines(dotGET\dotGET.queue) > 0 { dotGETqueue.send | .timerdotGETSend 0 30 dotGETqueue.send }
  else { .timerdotGETSend off }
}

ctcp ^*:.GET:* {
  if $2 == get {
    if ($read -w" $+ $3- $+ " dotGET\dotGET.all.db1 != $null) {
      if ($readini dotGET\dotGET.data main queuetype == 2) {
        if $readini(dotGET\dotGET.data,stats,sent) == $null { writeini dotGET\dotGET.data stats sent 1 } | else { writeini dotGET\dotGET.data stats sent $calc($readini(dotGET\dotGET.data,stats,sent) + 1) }
      queue.add Fserve $nick $3- | .timerPolarisSend 0 30 queue.send | .timer 1 1 queue.send | .notice $nick You has been added to the polaris queue. Filename: $3- [.GET] | dotGETd $nick added to polaris queue for $3- }
      else { dotGETqueue.add $nick " $+ $3- $+ " }
    }
    else { write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - WARNING: $nick Requested an unshared file. $3- | dotGETd WARNING: $nick Requested an unshared file. | .ctcpreply $nick .GET The file you requested, $3- is NOT shared. }
  }
  elseif ($2 == unget) {
    if ($3 != $null) {
      if ($read -w $+ $nick $+ * $+ $3- dotGET\dotGET.queue != $null)  { write -dl $+ $readn dotGET\dotGET.queue | .notice $nick Removed file from your queue. Filename: $3- [.GET] | dotGETd $nick unqueued $3- }
      else { .notice $nick You do not have that file queued. Filename: $3- [.GET] }
    }
  }
  ;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  elseif $2 == firewall.workaroundS { sockopen dotGETSR.firewallworkaround $3 $4 }
  elseif $2 == firewall.workaroundQ { sockopen dotGETQ.firewallworkaround $3 $4 }
  elseif $2 == version { .ctcpreply $nick .GET .GET Version %dotGET.version.number %dotGET.version.type - $lines(dotGET\dotGET.all.db1) files shared $dotGETresize(%dotGET.sizeshared) }
  elseif $2 == ver { .ctcpreply $nick .GETVER .GET Version %dotGET.version.number %dotGET.version.type }

  halt
}

alias dotget.unget.send { 
  %dotGET.queue.6- = $tcdr($tcdr($tcdr($tcdr($tcdr($1-))))))
  ctcp $1 .get unget %dotGET.queue.6-
}

alias dotGET.checkqueues {
  if $dialog(dotGETQueueResults) != $null { write -il1 dotGET\dotGET.status.dat There is a Queue window open already.  Please close it before starting a new queue search. | echo There is a Queue window open already.  Please close it before starting a new queue search. | dialog -v dotGETQueueResults }
  else {
    ;codecopy1
    sockclose dotGETSearch
    if %dotGET.firewall != $null { var %dotGET.port = %dotGET.firewall }
    else {
      :checkforport
      var %dotGET.port = $rand(1024,5000)
      if $portfree(%dotGET.port) != $true { goto checkforport }
    }
    socklisten dotGETQueues %dotGET.port
    dialog -md dotGETQueueResults dotGETQueueResults
    %dotGET.current.dl = 0
    ;sets # of lines
    .timerdotGETQueueupdateline 0 1 dotGETQueueupdateline
    ;ABCDEFG
    .msg %dotGET.datachan .checkmyqueues %dotGET.myip %dotGET.port
    set %dotGET.searchedlast $ctime
    dotGETd Getting queue lists
    write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - Getting queue lists
  }
}

dialog dotGETQueueResults {
  title "Your .GET Queues"
  size -1 -1 734 332
  list 1, 701 11 0 0, size
  button "Close", 2, 654 300 75 25, cancel
  list 4, 7 9 720 260, size vsbar
  text "Queue Position / Max Queues Per Person / Max Total Queues - Queued on -> Filename", 5, 13 279 432 16
  button "Remove From Queue", 3, 26 300 111 25
  button "Browse Users Files", 6, 243 300 111 25
  button "Refresh Queue List", 7, 457 300 111 25
}

on *:dialog:dotGETQueueResults:*:*: {
  if ($devent == sclick) && ($did == 2) { .timerdotGETQueueupdateline off | sockclose dotGETQueues }
  if ($devent == sclick) && ($did == 7) { dialog -c dotGETQueueResults | .timerdotGETQueueupdateline off | sockclose dotGETQueues | .timer 1 1 dotGET.checkqueues }
  if ($devent == sclick) && ($did == 3) { 
    var %dotGET.queue.line = $did(dotGETQueueResults,1,$did(dotGETQueueResults,4).sel).text
    %dotGET.queue.1 = $tcar(%dotGET.updates.lastline)
    .timer -m 1 250 dotget.unget.send %dotGET.queue.line
  }

  if ($devent == dclick) && ($did == 4) { 
    ;same as above 
    var %dotGET.queue.line = $did(dotGETQueueResults,1,$did(dotGETQueueResults,4).sel).text
    %dotGET.queue.1 = $tcar(%dotGET.updates.lastline)
    .timer -m 1 250 dotget.unget.send %dotGET.queue.line
  }

  if ($devent == sclick) && ($did == 6) { 

    if $dialog(dotGETResults) != $null { echo There is a search window open already.  Please close it before starting a new search. | write -il1 dotGET\dotGET.status.dat There is a search window open already.  Please close it before starting a new search. | dialog -v dotGETResults }
    var %dotGET.queue.line = $did(dotGETQueueResults,1,$did(dotGETQueueResults,4).sel).text
    %dotGET.queue.1 = $tcar(%dotGET.updates.lastline)
    dotGET.browse %dotGET.queue.1
  }
}

on *:sockopen:dotGETSendQueues: {
  set %dotGET.tries 0
  set %dotGET.lines $lines(dotGET\dotGET.searched1)  
  set %dotGET.current 0
  set %dotGET.ctime.test $ctime
  dotGETsendQueues
}

alias dotGETsendQueues {
  ;//sending queues
  if %dotGET.disabled == 1 { goto abort }
  if $sock(dotGETSendQueues).sq > 10 { goto queuefull }
  if $sock(dotGETSendQueues).status == active {
    :send
    if $sock(dotGETSendQueues).sq > 1000 { goto queuefull }
    else {
      if $calc($ctime - %dotGET.ctime.test) > 30 { goto abort }
      ;dotGETd . $sock(dotGETSendQueues).sq
      inc %dotGET.current
      var %dotGET.temp5 = $read -l $+ %dotGET.current dotGET\dotGET.searched1
      sockwrite -n dotGETSendQueues $me $readini dotGET\dotGET.data main queuesmax $readini dotGET\dotGET.data main queueseach %dotGET.temp5
      if (%dotGET.current < %dotGET.maxtosend) && (%dotGET.current < %dotGET.lines) { goto send }
      sockwrite -n dotGETSendQueues EOF
      sockclose dotGETSendQueues
      goto end
    }
  }
  :queuefull
  if %dotGET.tries < 100 { inc %dotGET.tries | .timer -m 1 200 dotGETsendsearch | return }
  else { goto abort }  
  :end
  sockclose dotGETSendSearch
  ;;;;.msg %dotGET.datachan Done Sending search.  Entire process took $calc($ctime - %dotGET.ctime.test) Seconds. ( $+ %dotGET.lines matches $+ )
  goto veryend
  :abort
  if $sock(dotGETSendSearch).status == active { sockwrite -n dotGETSendSearch EOF }
  sockclose dotGETSendSearch
  ;;;;.msg %dotGET.datachan Took more then 30 secs to send search.  Aborted Send.
  :veryend
  set %dotGET.searchinprogress 0
  write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - Search complete - %dotGET.lines Results sent to $nick
  dotGETd Search complete - %dotGET.lines Results sent to $nick
  unset %dotGET.tries %dotGET.lines %dotGET.current
}

on *:socklisten:dotGETQueues: {
  ;//accepting Queues download
  var %dotGETQ.socket = dotGETQ. $+ $rand(a,z) $+ $rand(a,z)  $+ $rand(a,z)  $+ $rand(a,z)  $+ $rand(a,z)  $+ $rand(a,z)
  sockaccept %dotGETQ.socket 
  write -il1 dotGET\dotGET.status.dat - $+ %dotGET.net $+ - Incoming QueueList From $sock(%dotGETQ.socket,1).ip at $fulldate
  dotGETd 11,1Incoming QueueList From $sock(%dotGETQ.socket,1).ip at $fulldate
}

on *:sockread:dotGETQ.*:{
  ;//downloading Queues results
  if ($sockerr > 0) { write -il1 dotGET\dotGET.status.dat Error occured while connected to the server | dotGETd Error occured while connected to the server | return }
  :nextread
  sockread %dotGET.updates.lastline
  if (%dotGET.updates.lastline == EOF) { sockclose $sockname | return }
  if (%dotGET.updates.lastline != $null) && ($dialog(dotGETQueueResults) != $null) {

    did -a dotGETQueueResults 1 %dotGET.updates.lastline

    ;echo -s Queue Results: %dotGET.updates.lastline
  }
  if ($sockbr == 0) return
  goto nextread
  if ($sockbr == 0) return
  if (%dotGET.update.lastline == $null) %dotGET.updates.lastline = -
}

alias dotGETQueueupdateline {
  if $did(dotGETQueueResults,1).lines > $did(dotGETQueueResults,4).lines {
    if $calc($ctime - %dotGET.ctime) < 1) { return }
    set %dotGET.ctime $ctime
    var %dotGET.numlines = $did(dotGETQueueResults,1).lines
    :loop
    if %dotGET.current.dl >= %dotGET.numlines { goto end }
    inc %dotGET.current.dl
    var %dotGET.updates.lastline = $did(dotGETQueueResults,1,%dotGET.current.dl).text
    var %dotGET.updates.lastline.1 = $tcar(%dotGET.updates.lastline)
    var %dotGET.updates.lastline.2 = $tcar($tcdr(%dotGET.updates.lastline))
    var %dotGET.updates.lastline.3 = $tcar($tcdr($tcdr(%dotGET.updates.lastline)))
    var %dotGET.updates.lastline.4 = $tcar($tcdr($tcdr($tcdr(%dotGET.updates.lastline))))
    ;var %dotGET.updates.lastline.5 = $tcar($tcdr($tcdr($tcdr($tcdr(%dotGET.updates.lastline)))))
    var %dotGET.updates.lastline.6- = $tcdr($tcdr($tcdr($tcdr($tcdr(%dotGET.updates.lastline))))))
    did -a dotGETQueueResults 4 %dotGET.updates.lastline.4 / %dotGET.updates.lastline.3 / %dotGET.updates.lastline.2 - %dotGET.updates.lastline.1 -> %dotGET.updates.lastline.6-
    goto loop
    :end
  }
}

alias dotGETRcv {
  var %dotGET.rcv.bw 0
  var %i = 1
  while (%i <= $get(0)) {
    ; echo -a ( $+ %i $+ ) Receiving $get(%i).file from $get(%i) $+ , at $dotGETResize2($get(%i).cps) k/s ( $+ $get(%i).pc $+ % - $dotGETResize($get(%i).rcvd) $+ / $+ $dotGETResize($get(%i).size) $+ )
    inc %dotGET.rcv.bw $get(%i).cps
    inc %i
  }
  ;echo -a Downloading Total: $dotGETResize2(%dotGET.rcv.bw) kb/s ( %dotGET.rcv.bw b/sec )
  return %dotGET.rcv.bw
}

alias dotGETSend { 
  var %dotGET.Send.bw 0
  var %i = 1
  while (%i <= $send(0)) {
    ;echo -a ( $+ %i $+ ) Sending $send(%i).file to $send(%i) $+ , at $dotGETResize2($send(%i).cps) k/s ( $+ $send(%i).pc $+ % - $dotGETResize($send(%i).sent) $+ / $+ $dotGETResize($send(%i).size) $+ )
    inc %dotGET.send.bw $send(%i).cps
    inc %i
  }
  ;echo -a Uploading Total: $dotGETResize2(%dotGET.send.bw) kb/s ( %dotGET.send.bw b/sec )
  return %dotGET.send.bw
}
